Package org.apache.sis.referencing.datum

# Class DefaultParametricDatum

Object
FormattableObject
AbstractIdentifiedObject
AbstractDatum
DefaultParametricDatum

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `Datum`, `IdentifiedObject`

public class DefaultParametricDatum extends AbstractDatum
Defines the origin of a parametric coordinate reference system.

## Creating new parametric datum instances

New instances can be created either directly by specifying all information to a factory method (choices 2 and 3 below), or indirectly by specifying the identifier of an entry in a database (choices 1 below).

1. Create a `ParametricDatum` from an identifier in a database by invoking `DatumAuthorityFactory​.createParametricDatum(String)`.
2. Create a `ParametricDatum` by invoking the `DatumFactory​.createParametricDatum(…)` method, (implemented for example by `GeodeticObjectFactory`).
3. Create a `DefaultParametricDatum` by invoking the constructor.

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.7
See Also:
  - `DefaultParametricCS`
  - `DefaultParametricCRS`
  - `GeodeticAuthorityFactory​.createParametricDatum(String)`
  - Serialized Form

Defined in the `sis-referencing` module

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface Datum

  `ANCHOR_POINT_KEY, DOMAIN_OF_VALIDITY_KEY, REALIZATION_EPOCH_KEY, SCOPE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultParametricDatum(Map<String,?> properties)`
  Creates a parametric datum from the given properties.
  `protected`
  `DefaultParametricDatum(DefaultParametricDatum datum)`
  Creates a new datum with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this datum as a Well Known Text `ParametricDatum[…]` element.

  ### Methods inherited from class AbstractDatum

  `castOrCopy, computeHashCode, equals, getAnchorPoint, getDomainOfValidity, getInterface, getRealizationEpoch, getScope, isHeuristicMatchForName`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- ## Constructor Details

  - ### DefaultParametricDatum

    public DefaultParametricDatum(Map<String,?> properties)
    Creates a parametric datum from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `Identifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
    "anchorPoint" | `InternationalString` or `String` | `AbstractDatum.getAnchorPoint()`
    "realizationEpoch" | `Date` | `AbstractDatum.getRealizationEpoch()`
    "domainOfValidity" | `Extent` | `AbstractDatum.getDomainOfValidity()`
    "scope" | `InternationalString` or `String` | `AbstractDatum.getScope()`

    Parameters:
      `properties` - the properties to be given to the identified object.
    See Also:
      - `GeodeticObjectFactory​.createParametricDatum(Map)`

  - ### DefaultParametricDatum

    protected DefaultParametricDatum(DefaultParametricDatum datum)
    Creates a new datum with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Warning: in a future SIS version, the parameter type may be changed to `org​.opengis​.referencing​.datum​.ParametricDatum`. This change is pending GeoAPI revision.
    Parameters:
      `datum` - the datum to copy.

- ## Method Details

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this datum as a Well Known Text `ParametricDatum[…]` element.
    Compatibility note: `ParametricDatum` is defined in the WKT 2 specification only.
    Overrides:
      `formatTo` in class `AbstractDatum`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"ParametricDatum"`.
    See Also:
      - WKT 2 specification